Ruby: include/ruby/internal/error.h File Reference

Ruby 3.0.5p211 (2022-11-24 revision ba5cf0f7c52d4d35cc6a173c89eda98ceffa2dcf)

Macros | Enumerations | Functions
error.h File Reference

Declares rb_raise(). More...

`#include "ruby/internal/dllexport.h"`
`#include "ruby/internal/value.h"`
`#include "ruby/backward/2/attributes.h"`

Go to the source code of this file.

## Macros
#define | RB_IO_WAIT_READABLE RB_IO_WAIT_READABLE
#define | RB_IO_WAIT_WRITABLE RB_IO_WAIT_WRITABLE
#define | ruby_verbose (*rb_ruby_verbose_ptr())
#define | ruby_debug (*rb_ruby_debug_ptr())

## Enumerations
enum | rb_warning_category_t { RB_WARN_CATEGORY_NONE , RB_WARN_CATEGORY_DEPRECATED , RB_WARN_CATEGORY_EXPERIMENTAL , RB_WARN_CATEGORY_ALL_BITS = 0x6 }
enum | rb_io_wait_readwrite { RB_IO_WAIT_READABLE , RB_IO_WAIT_WRITABLE }

## Functions
VALUE | rb_errinfo (void)
| The current exception in the current thread. More...
void | rb_set_errinfo (VALUE)
| Sets the current exception (`$!`) to the given value. More...
void | rb_raise (VALUE, const char *,...)
void | rb_fatal (const char *,...)
void | rb_bug (const char *,...)
void | rb_bug_errno (const char *, int)
void | rb_sys_fail (const char *)
void | rb_sys_fail_str (VALUE)
void | rb_mod_sys_fail (VALUE, const char *)
void | rb_mod_sys_fail_str (VALUE, VALUE)
void | rb_readwrite_sys_fail (enum rb_io_wait_readwrite, const char *)
void | rb_iter_break (void)
void | rb_iter_break_value (VALUE)
void | rb_exit (int)
void | rb_notimplement (void)
VALUE | rb_syserr_new (int, const char *)
VALUE | rb_syserr_new_str (int n, VALUE arg)
void | rb_syserr_fail (int, const char *)
void | rb_syserr_fail_str (int, VALUE)
void | rb_mod_syserr_fail (VALUE, int, const char *)
void | rb_mod_syserr_fail_str (VALUE, int, VALUE)
void | rb_readwrite_syserr_fail (enum rb_io_wait_readwrite, int, const char *)
void | rb_unexpected_type (VALUE, int)
VALUE * | rb_ruby_verbose_ptr (void)
VALUE * | rb_ruby_debug_ptr (void)
void | rb_warning (const char *,...)
void | rb_category_warning (rb_warning_category_t, const char *,...)
void | rb_compile_warning (const char *, int, const char *,...)
void | rb_category_compile_warn (rb_warning_category_t, const char *, int, const char *,...)
void | rb_sys_warning (const char *,...)
void | rb_warn (const char *,...)
void | rb_category_warn (rb_warning_category_t, const char *,...)
void | rb_compile_warn (const char *, int, const char *,...)

## Detailed Description

Declares rb_raise().

Author
  Ruby developers ruby-.nosp@m.core.nosp@m.@ruby.nosp@m.-lan.nosp@m.g.org

Copyright
  This file is a part of the programming language Ruby. Permission is hereby granted, to either redistribute and/or modify this file, provided that the conditions mentioned in the file COPYING are met. Consult the file for details.

Warning
  Symbols prefixed with either `RBIMPL` or `rbimpl` are implementation details. Don't take them as canon. They could rapidly appear then vanish. The name (path) of this header file is also an implementation detail. Do not expect it to persist at the place it is now. Developers are free to move it anywhere anytime at will.

Note
  To ruby-core: remember that this header can be possibly recursively included from extension libraries written in C++. Do not expect for instance `__VA_ARGS__` is always available. We assume C99 for ruby itself but we don't assume languages of extension libraries. They could be written in C++98.

Definition in file error.h.

## Macro Definition Documentation

## ◆ RB_IO_WAIT_READABLE

#define RB_IO_WAIT_READABLE RB_IO_WAIT_READABLE

Definition at line 41 of file error.h.

## ◆ RB_IO_WAIT_WRITABLE

#define RB_IO_WAIT_WRITABLE RB_IO_WAIT_WRITABLE

Definition at line 42 of file error.h.

## ◆ ruby_debug

#define ruby_debug (*rb_ruby_debug_ptr())

Definition at line 69 of file error.h.

## ◆ ruby_verbose

#define ruby_verbose (*rb_ruby_verbose_ptr())

Definition at line 68 of file error.h.

## Enumeration Type Documentation

## ◆ rb_io_wait_readwrite

enum rb_io_wait_readwrite

Enumerator
RB_IO_WAIT_READABLE |
RB_IO_WAIT_WRITABLE |

Definition at line 40 of file error.h.

## ◆ rb_warning_category_t

enum rb_warning_category_t

Enumerator
RB_WARN_CATEGORY_NONE |
RB_WARN_CATEGORY_DEPRECATED |
RB_WARN_CATEGORY_EXPERIMENTAL |
RB_WARN_CATEGORY_ALL_BITS |

Definition at line 32 of file error.h.

## Function Documentation

## ◆ rb_exit()

void rb_exit | ( | int | status | ) |

Definition at line 4416 of file process.c.

References INT2NUM, rb_class_new_instance(), rb_eSystemExit, rb_exc_raise(), rb_str_new2, and ruby_stop().

Referenced by rb_f_abort(), rb_f_exit(), and rb_thread_kill().

## ◆ rb_iter_break()

void rb_iter_break | ( | void |  | ) |

Definition at line 1786 of file vm.c.

References Qnil.

Referenced by DEFINE_ENUMFUNCS().

## ◆ rb_iter_break_value()

void rb_iter_break_value | ( | VALUE | val | ) |

Definition at line 1792 of file vm.c.

## ◆ rb_readwrite_sys_fail()

void rb_readwrite_sys_fail | ( | enum | rb_io_wait_readwrite,
|  | const char * | mesg
| ) |  |

Definition at line 13116 of file io.c.

References rb_readwrite_syserr_fail().

## ◆ rb_readwrite_syserr_fail()

void rb_readwrite_syserr_fail | ( | enum | rb_io_wait_readwrite,
|  | int | n,
|  | const char * | mesg
| ) |  |

Definition at line 13122 of file io.c.

References EINPROGRESS, EWOULDBLOCK, Qnil, rb_bug(), rb_class_new_instance(), rb_exc_raise(), RB_IO_WAIT_READABLE, RB_IO_WAIT_WRITABLE, rb_mod_syserr_fail_str(), rb_mWaitReadable, rb_mWaitWritable, and rb_str_new2.

Referenced by rb_readwrite_sys_fail(), rsock_s_accept_nonblock(), and rsock_s_recvfrom_nonblock().

## ◆ rb_ruby_debug_ptr()

VALUE * rb_ruby_debug_ptr | ( | void |  | ) |

Definition at line 3775 of file vm.c.

References rb_ractor_struct::debug.

## ◆ rb_ruby_verbose_ptr()

VALUE * rb_ruby_verbose_ptr | ( | void |  | ) |

Definition at line 3768 of file vm.c.

References rb_ractor_struct::verbose.